package com.fp.persistence.parmas.fun;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TARMINVENTARIOSUBIDOPORPERSONA*/
@Embeddable
public class TarmInventarioSubidoPorPersonaKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CLASE", nullable=false,updatable=false)

/**
* null
*/
private String clase;

@Column(name="PERSONCODE", nullable=false,updatable=false)

/**
* null
*/
private Integer personcode;

/**Contructor por defecto*/
public TarmInventarioSubidoPorPersonaKey(){}
/**Contructor de TarmInventarioSubidoPorPersonaKey
@param pClase null
@param pPersoncode null
*/
public TarmInventarioSubidoPorPersonaKey(String pClase,Integer pPersoncode){
 clase=pClase;
 personcode=pPersoncode;
}
/**Obtiene el valor de clase
@return valor de clase*/
public String getClase(){
  return clase;
}
/**Fija el valor de clase
@param pClase nuevo Valor de clase*/
public void setClase(String pClase){
  clase=pClase;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Implementacion de la comparacion de TarmInventarioSubidoPorPersonaKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TarmInventarioSubidoPorPersonaKey))return false;
  TarmInventarioSubidoPorPersonaKey that = (TarmInventarioSubidoPorPersonaKey) o;
  if (this.getClase() == null || that.getClase() == null){
      return false;
  }
  if (! this.getClase().equals(that.getClase())){
    return false;
  }
  if (this.getPersoncode() == null || that.getPersoncode() == null){
      return false;
  }
  if (! this.getPersoncode().equals(that.getPersoncode())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TarmInventarioSubidoPorPersonaKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getClase() == null ? 0 : this.getClase().hashCode());
    result = result * 37 + (this.getPersoncode() == null ? 0 : this.getPersoncode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
